## hvml-dom-ruler 0.0.1

=== CMakeLists.txt ===
#
# 
#                           IMPORTANT NOTICE
# 
#  The following open source license statement does not apply to any
#  entity in the Exception List published by FMSoft.
# 
#  For more information, please visit:
# 
#  https://www.fmsoft.cn/exception-list
# 
#
#   This file is part of DOM Ruler. DOM Ruler is a library to
#   maintain a DOM tree, lay out and stylize the DOM nodes by
#   using CSS (Cascaded Style Sheets).
#
#   Copyright (C) 2021, 2022 Beijing FMSoft Technologies Co., Ltd.
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU Lesser General License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU Lesser General License for more details.
#
#   You should have received a copy of the GNU Lesser General License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#   Or,
#
#   As this program is a library, any link to this program must follow
#   GNU Lesser General License version 3 (LGPLv3). If you cannot accept
#   LGPLv3, you need to be licensed from FMSoft.
#
#   If you have got a commercial license of this program, please use it
#   under the terms and conditions of the commercial license.
#
#   For more information about the commercial license, please refer to
#   <http://www.minigui.com/blog/minigui-licensing-policy/>.
#

cmake_minimum_required(VERSION 3.10)

project(DOMRuler)

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

find_package(GLIB 2.0 REQUIRED)
find_package(PurC)

add_subdirectory(src)

=== src/CMakeLists.txt ===
#
# 
#                           IMPORTANT NOTICE
# 
#  The following open source license statement does not apply to any
#  entity in the Exception List published by FMSoft.
# 
#  For more information, please visit:
# 
#  https://www.fmsoft.cn/exception-list
# 
#
#   This file is part of DOM Ruler. DOM Ruler is a library to
#   maintain a DOM tree, lay out and stylize the DOM nodes by
#   using CSS (Cascaded Style Sheets).
#
#   Copyright (C) 2021, 2022 Beijing FMSoft Technologies Co., Ltd.
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU Lesser General License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU Lesser General License for more details.
#
#   You should have received a copy of the GNU Lesser General License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#   Or,
#
#   As this program is a library, any link to this program must follow
#   GNU Lesser General License version 3 (LGPLv3). If you cannot accept
#   LGPLv3, you need to be licensed from FMSoft.
#
#   If you have got a commercial license of this program, please use it
#   under the terms and conditions of the commercial license.
#
#   For more information about the commercial license, please refer to
#   <http://www.minigui.com/blog/minigui-licensing-policy/>.
#

cmake_minimum_required(VERSION 3.10)

add_subdirectory(third-party)
add_subdirectory(layout)
add_subdirectory(test)
add_subdirectory(tools)

=== src/layout/CMakeLists.txt ===
#
#
#                           IMPORTANT NOTICE
#
#  The following open source license statement does not apply to any
#  entity in the Exception List published by FMSoft.
#
#  For more information, please visit:
#
#  https://www.fmsoft.cn/exception-list
#
#
#   This file is part of DOM Ruler. DOM Ruler is a library to
#   maintain a DOM tree, lay out and stylize the DOM nodes by
#   using CSS (Cascaded Style Sheets).
#
#   Copyright (C) 2021, 2022 Beijing FMSoft Technologies Co., Ltd.
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU Lesser General License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU Lesser General License for more details.
#
#   You should have received a copy of the GNU Lesser General License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#   Or,
#
#   As this program is a library, any link to this program must follow
#   GNU Lesser General License version 3 (LGPLv3). If you cannot accept
#   LGPLv3, you need to be licensed from FMSoft.
#
#   If you have got a commercial license of this program, please use it
#   under the terms and conditions of the commercial license.
#
#   For more information about the commercial license, please refer to
#   <http://www.minigui.com/blog/minigui-licensing-policy/>.
#

cmake_minimum_required(VERSION 3.10)

project(domruler VERSION 1.2.1)

#add_definitions(-D_DEBUG)

list(APPEND domruler_INCLUDE_DIRECTORIES
    ${CMAKE_SOURCE_DIR}/src/third-party/libparserutils/include
    ${CMAKE_SOURCE_DIR}/src/third-party/libwapcaplet/include
    ${CMAKE_SOURCE_DIR}/src/third-party/libcss/include
    ${CMAKE_SOURCE_DIR}/src/layout/include
    ${CMAKE_SOURCE_DIR}/src/layout/src
)

list(APPEND domruler_SOURCES
    src/node.c
    src/select.c
    src/utils.c
    src/css_select.c
    src/layout.c
    src/layout_grid.c
    src/hl_dom_element_node.c
    src/hl_pcdom_element_t.c
    src/domruler.c
)

include_directories(${domruler_INCLUDE_DIRECTORIES} ${GLIB_INCLUDE_DIRS} ${PURC_INCLUDE_DIRS})
link_directories(${GLIB_LIBRARIES})
add_library(domruler SHARED ${domruler_SOURCES})
set_target_properties(domruler PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION ${PROJECT_VERSION_MAJOR})
target_link_libraries(domruler css  ${PURC_LIBRARIES})


configure_file(domruler.pc.in domruler.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/domruler.pc DESTINATION lib/pkgconfig)
install(FILES ${CMAKE_SOURCE_DIR}/src/layout/include/domruler.h DESTINATION include)
install(TARGETS domruler DESTINATION lib)

=== src/test/CMakeLists.txt ===
#
# 
#                           IMPORTANT NOTICE
# 
#  The following open source license statement does not apply to any
#  entity in the Exception List published by FMSoft.
# 
#  For more information, please visit:
# 
#  https://www.fmsoft.cn/exception-list
# 
#
#   This file is part of DOM Ruler. DOM Ruler is a library to
#   maintain a DOM tree, lay out and stylize the DOM nodes by
#   using CSS (Cascaded Style Sheets).
#
#   Copyright (C) 2021 Beijing FMSoft Technologies Co., Ltd.
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU Lesser General License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU Lesser General License for more details.
#
#   You should have received a copy of the GNU Lesser General License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#   Or,
#
#   As this program is a library, any link to this program must follow
#   GNU Lesser General License version 3 (LLGPLv3). If you cannot accept
#   LLGPLv3, you need to be licensed from FMSoft.
#
#   If you have got a commercial license of this program, please use it
#   under the terms and conditions of the commercial license.
#
#   For more information about the commercial license, please refer to
#   <http://www.minigui.com/blog/minigui-licensing-policy/>.
#

cmake_minimum_required(VERSION 3.10)

project(css_select_test)
add_definitions(-D_DEBUG)

# node
list(APPEND node_test_INCLUDE_DIRECTORIES
    ${CMAKE_SOURCE_DIR}/src/layout/include
    ${CMAKE_SOURCE_DIR}/src/third-party/libparserutils/include
    ${CMAKE_SOURCE_DIR}/src/third-party/libwapcaplet/include
    ${CMAKE_SOURCE_DIR}/src/third-party/libcss/include
    ${CMAKE_SOURCE_DIR}/src/layout/src
)

list(APPEND node_test_SOURCES
    ${CMAKE_SOURCE_DIR}/src/test/node_test.c
)

include_directories(${node_test_INCLUDE_DIRECTORIES} ${GLIB_INCLUDE_DIRS})
add_executable(node_test ${node_test_SOURCES})
target_link_libraries(node_test domruler ${GLIB_LIBRARIES})

# css
list(APPEND css_select_test_INCLUDE_DIRECTORIES
    ${CMAKE_SOURCE_DIR}/src/layout/include
    ${CMAKE_SOURCE_DIR}/src/third-party/libparserutils/include
    ${CMAKE_SOURCE_DIR}/src/third-party/libwapcaplet/include
    ${CMAKE_SOURCE_DIR}/src/third-party/libcss/include
    ${CMAKE_SOURCE_DIR}/src/layout/src
)

list(APPEND css_select_test_SOURCES
    ${CMAKE_SOURCE_DIR}/src/test/css_select.c
)

include_directories(${css_select_test_INCLUDE_DIRECTORIES} ${GLIB_INCLUDE_DIRS})
add_executable(css_select_test ${css_select_test_SOURCES})
target_link_libraries(css_select_test domruler ${GLIB_LIBRARIES})

list(APPEND css_select_test2_INCLUDE_DIRECTORIES
    ${CMAKE_SOURCE_DIR}/src/layout/include
    ${CMAKE_SOURCE_DIR}/src/third-party/libparserutils/include
    ${CMAKE_SOURCE_DIR}/src/third-party/libwapcaplet/include
    ${CMAKE_SOURCE_DIR}/src/third-party/libcss/include
    ${CMAKE_SOURCE_DIR}/src/layout/src
)

list(APPEND css_select_test2_SOURCES
    ${CMAKE_SOURCE_DIR}/src/test/css_select2.c
)

include_directories(${css_select_test2_INCLUDE_DIRECTORIES} ${GLIB_INCLUDE_DIRS})
add_executable(css_select_test2 ${css_select_test2_SOURCES})
target_link_libraries(css_select_test2 domruler ${GLIB_LIBRARIES})


# layout_test
list(APPEND layout_test_INCLUDE_DIRECTORIES
    ${CMAKE_SOURCE_DIR}/src/layout/include
)

list(APPEND layout_test_SOURCES
    ${CMAKE_SOURCE_DIR}/src/test/layout_test.c
)

include_directories(${layout_test_INCLUDE_DIRECTORIES} ${GLIB_INCLUDE_DIRS})
add_executable(layout_test ${layout_test_SOURCES})
target_link_libraries(layout_test domruler ${GLIB_LIBRARIES})

# layout_pcdom_element
list(APPEND layout_pcdom_element_INCLUDE_DIRECTORIES
    ${CMAKE_SOURCE_DIR}/src/layout/include
)

list(APPEND layout_pcdom_element_SOURCES
    ${CMAKE_SOURCE_DIR}/src/test/layout_pcdom_element.c
)

include_directories(${layout_pcdom_element_INCLUDE_DIRECTORIES} ${GLIB_INCLUDE_DIRS})
add_executable(layout_pcdom_element ${layout_pcdom_element_SOURCES})
target_link_libraries(layout_pcdom_element domruler ${GLIB_LIBRARIES})

=== src/third-party/CMakeLists.txt ===
#
# 
#                           IMPORTANT NOTICE
# 
#  The following open source license statement does not apply to any
#  entity in the Exception List published by FMSoft.
# 
#  For more information, please visit:
# 
#  https://www.fmsoft.cn/exception-list
# 
#
#   This file is part of DOM Ruler. DOM Ruler is a library to
#   maintain a DOM tree, lay out and stylize the DOM nodes by
#   using CSS (Cascaded Style Sheets).
#
#   Copyright (C) 2021 Beijing FMSoft Technologies Co., Ltd.
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU Lesser General License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU Lesser General License for more details.
#
#   You should have received a copy of the GNU Lesser General License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#   Or,
#
#   As this program is a library, any link to this program must follow
#   GNU Lesser General License version 3 (LGPLv3). If you cannot accept
#   LGPLv3, you need to be licensed from FMSoft.
#
#   If you have got a commercial license of this program, please use it
#   under the terms and conditions of the commercial license.
#
#   For more information about the commercial license, please refer to
#   <http://www.minigui.com/blog/minigui-licensing-policy/>.
#

cmake_minimum_required(VERSION 3.10)

add_subdirectory(libwapcaplet)
add_subdirectory(libparserutils)
add_subdirectory(libcss)

=== src/tools/CMakeLists.txt ===
#
# 
#                           IMPORTANT NOTICE
# 
#  The following open source license statement does not apply to any
#  entity in the Exception List published by FMSoft.
# 
#  For more information, please visit:
# 
#  https://www.fmsoft.cn/exception-list
# 
#
#   This file is part of DOM Ruler. DOM Ruler is a library to
#   maintain a DOM tree, lay out and stylize the DOM nodes by
#   using CSS (Cascaded Style Sheets).
#
#   Copyright (C) 2021 Beijing FMSoft Technologies Co., Ltd.
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU Lesser General License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU Lesser General License for more details.
#
#   You should have received a copy of the GNU Lesser General License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#   Or,
#
#   As this program is a library, any link to this program must follow
#   GNU Lesser General License version 3 (LGPLv3). If you cannot accept
#   LGPLv3, you need to be licensed from FMSoft.
#
#   If you have got a commercial license of this program, please use it
#   under the terms and conditions of the commercial license.
#
#   For more information about the commercial license, please refer to
#   <http://www.minigui.com/blog/minigui-licensing-policy/>.
#

cmake_minimum_required(VERSION 3.10)

add_subdirectory(layout_html)

=== src/third-party/libcss/CMakeLists.txt ===
#
# 
#                           IMPORTANT NOTICE
# 
#  The following open source license statement does not apply to any
#  entity in the Exception List published by FMSoft.
# 
#  For more information, please visit:
# 
#  https://www.fmsoft.cn/exception-list
# 
#
#   This file is part of DOM Ruler. DOM Ruler is a library to
#   maintain a DOM tree, lay out and stylize the DOM nodes by
#   using CSS (Cascaded Style Sheets).
#
#   Copyright (C) 2021 Beijing FMSoft Technologies Co., Ltd.
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU Lesser General License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU Lesser General License for more details.
#
#   You should have received a copy of the GNU Lesser General License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#   Or,
#
#   As this program is a library, any link to this program must follow
#   GNU Lesser General License version 3 (LLLGPLv3). If you cannot accept
#   LLLGPLv3, you need to be licensed from FMSoft.
#
#   If you have got a commercial license of this program, please use it
#   under the terms and conditions of the commercial license.
#
#   For more information about the commercial license, please refer to
#   <http://www.minigui.com/blog/minigui-licensing-policy/>.
#

cmake_minimum_required(VERSION 3.10)

project(css)
add_definitions(-fPIC)

list(APPEND css_INCLUDE_DIRECTORIES
    ../libparserutils/include
    ../libwapcaplet/include
    include
    src
)

list(APPEND css_SOURCES
    src/charset/detect.c
    src/parse/propstrings.c
    src/parse/properties/autogenerated_break_before.c
    src/parse/properties/autogenerated_page_break_before.c
    src/parse/properties/autogenerated_flex_direction.c
    src/parse/properties/autogenerated_border_bottom_width.c
    src/parse/properties/border_color.c
    src/parse/properties/autogenerated_padding_top.c
    src/parse/properties/autogenerated_outline_style.c
    src/parse/properties/autogenerated_margin_left.c
    src/parse/properties/margin.c
    src/parse/properties/autogenerated_break_after.c
    src/parse/properties/autogenerated_margin_bottom.c
    src/parse/properties/autogenerated_caption_side.c
    src/parse/properties/font.c
    src/parse/properties/border_width.c
    src/parse/properties/autogenerated_stress.c
    src/parse/properties/autogenerated_height.c
    src/parse/properties/content.c
    src/parse/properties/autogenerated_right.c
    src/parse/properties/autogenerated_border_top.c
    src/parse/properties/padding.c
    src/parse/properties/autogenerated_background_attachment.c
    src/parse/properties/autogenerated_list_style_position.c
    src/parse/properties/autogenerated_column_count.c
    src/parse/properties/css_property_parser_gen.c
    src/parse/properties/play_during.c
    src/parse/properties/autogenerated_background_image.c
    src/parse/properties/autogenerated_left.c
    src/parse/properties/autogenerated_pause_after.c
    src/parse/properties/autogenerated_padding_right.c
    src/parse/properties/autogenerated_writing_mode.c
    src/parse/properties/autogenerated_border_right_color.c
    src/parse/properties/autogenerated_break_inside.c
    src/parse/properties/border.c
    src/parse/properties/list_style_type.c
    src/parse/properties/autogenerated_counter_reset.c
    src/parse/properties/flex.c
    src/parse/properties/autogenerated_box_sizing.c
    src/parse/properties/outline.c
    src/parse/properties/cursor.c
    src/parse/properties/autogenerated_margin_top.c
    src/parse/properties/autogenerated_page_break_after.c
    src/parse/properties/autogenerated_color.c
    src/parse/properties/autogenerated_overflow_y.c
    src/parse/properties/column_rule.c
    src/parse/properties/autogenerated_flex_shrink.c
    src/parse/properties/autogenerated_margin_right.c
    src/parse/properties/opacity.c
    src/parse/properties/background_position.c
    src/parse/properties/autogenerated_padding_side.c
    src/parse/properties/autogenerated_order.c
    src/parse/properties/autogenerated_border_left_color.c
    src/parse/properties/autogenerated_border_right.c
    src/parse/properties/utils.c
    src/parse/properties/autogenerated_column_width.c
    src/parse/properties/pause.c
    src/parse/properties/autogenerated_speak.c
    src/parse/properties/autogenerated_volume.c
    src/parse/properties/properties.c
    src/parse/properties/autogenerated_border_top_style.c
    src/parse/properties/autogenerated_position.c
    src/parse/properties/autogenerated_border_left_width.c
    src/parse/properties/autogenerated_widows.c
    src/parse/properties/autogenerated_padding_bottom.c
    src/parse/properties/autogenerated_side.c
    src/parse/properties/autogenerated_outline_color.c
    src/parse/properties/text_decoration.c
    src/parse/properties/autogenerated_clear.c
    src/parse/properties/autogenerated_max_height.c
    src/parse/properties/autogenerated_bottom.c
    src/parse/properties/list_style.c
    src/parse/properties/voice_family.c
    src/parse/properties/autogenerated_border_bottom_style.c
    src/parse/properties/overflow.c
    src/parse/properties/autogenerated_flex_grow.c
    src/parse/properties/autogenerated_width.c
    src/parse/properties/autogenerated_flex_basis.c
    src/parse/properties/autogenerated_z_index.c
    src/parse/properties/autogenerated_float.c
    src/parse/properties/font_weight.c
    src/parse/properties/autogenerated_background_color.c
    src/parse/properties/autogenerated_column_rule_width.c
    src/parse/properties/autogenerated_border_collapse.c
    src/parse/properties/autogenerated_table_layout.c
    src/parse/properties/azimuth.c
    src/parse/properties/autogenerated_speak_header.c
    src/parse/properties/autogenerated_min_height.c
    src/parse/properties/autogenerated_background_repeat.c
    src/parse/properties/autogenerated_page_break_inside.c
    src/parse/properties/autogenerated_border_bottom.c
    src/parse/properties/autogenerated_overflow_x.c
    src/parse/properties/autogenerated_cue_after.c
    src/parse/properties/autogenerated_top.c
    src/parse/properties/autogenerated_outline_width.c
    src/parse/properties/autogenerated_max_width.c
    src/parse/properties/flex_flow.c
    src/parse/properties/autogenerated_richness.c
    src/parse/properties/autogenerated_border_side_width.c
    src/parse/properties/autogenerated_padding_left.c
    src/parse/properties/autogenerated_font_size.c
    src/parse/properties/autogenerated_visibility.c
    src/parse/properties/autogenerated_speak_numeral.c
    src/parse/properties/autogenerated_letter_spacing.c
    src/parse/properties/autogenerated_pitch_range.c
    src/parse/properties/autogenerated_text_indent.c
    src/parse/properties/autogenerated_speech_rate.c
    src/parse/properties/autogenerated_border_top_color.c
    src/parse/properties/autogenerated_text_align.c
    src/parse/properties/autogenerated_align_content.c
    src/parse/properties/border_style.c
    src/parse/properties/autogenerated_white_space.c
    src/parse/properties/autogenerated_column_fill.c
    src/parse/properties/autogenerated_font_variant.c
    src/parse/properties/autogenerated_counter_increment.c
    src/parse/properties/autogenerated_border_side_style.c
    src/parse/properties/autogenerated_word_spacing.c
    src/parse/properties/autogenerated_margin_side.c
    src/parse/properties/autogenerated_orphans.c
    src/parse/properties/cue.c
    src/parse/properties/autogenerated_line_height.c
    src/parse/properties/autogenerated_pitch.c
    src/parse/properties/border_spacing.c
    src/parse/properties/autogenerated_justify_content.c
    src/parse/properties/autogenerated_unicode_bidi.c
    src/parse/properties/autogenerated_border_bottom_color.c
    src/parse/properties/autogenerated_direction.c
    src/parse/properties/autogenerated_column_rule_style.c
    src/parse/properties/autogenerated_text_transform.c
    src/parse/properties/font_family.c
    src/parse/properties/autogenerated_border_top_width.c
    src/parse/properties/autogenerated_align_items.c
    src/parse/properties/clip.c
    src/parse/properties/autogenerated_speak_punctuation.c
    src/parse/properties/autogenerated_border_right_width.c
    src/parse/properties/autogenerated_align_self.c
    src/parse/properties/autogenerated_border_left.c
    src/parse/properties/autogenerated_column_rule_color.c
    src/parse/properties/autogenerated_list_style_image.c
    src/parse/properties/autogenerated_font_style.c
    src/parse/properties/autogenerated_display.c
    src/parse/properties/autogenerated_cue_before.c
    src/parse/properties/autogenerated_min_width.c
    src/parse/properties/background.c
    src/parse/properties/autogenerated_vertical_align.c
    src/parse/properties/autogenerated_column_span.c
    src/parse/properties/autogenerated_empty_cells.c
    src/parse/properties/columns.c
    src/parse/properties/autogenerated_flex_wrap.c
    src/parse/properties/autogenerated_column_gap.c
    src/parse/properties/autogenerated_pause_before.c
    src/parse/properties/autogenerated_border_side_color.c
    src/parse/properties/quotes.c
    src/parse/properties/autogenerated_border_right_style.c
    src/parse/properties/autogenerated_border_left_style.c
    src/parse/properties/elevation.c
    src/parse/properties/grid_template_columns.c
    src/parse/properties/grid_template_rows.c
    src/parse/properties/autogenerated_grid_template_columns.c
    src/parse/properties/autogenerated_grid_template_rows.c
    src/parse/properties/autogenerated_grid_column_start.c
    src/parse/properties/autogenerated_grid_column_end.c
    src/parse/properties/autogenerated_grid_row_start.c
    src/parse/properties/autogenerated_grid_row_end.c
    src/parse/properties/autogenerated_border_top_left_radius.c
    src/parse/properties/autogenerated_border_top_right_radius.c
    src/parse/properties/autogenerated_border_bottom_left_radius.c
    src/parse/properties/autogenerated_border_bottom_right_radius.c
    src/parse/properties/autogenerated_text_align_last.c
    src/parse/properties/autogenerated_text_justify.c
    src/parse/properties/autogenerated_text_overflow.c
    src/parse/properties/text_overflow.c
    #### begin
    src/parse/properties/autogenerated_text_shadow.c
    src/parse/properties/text_shadow.c
    src/parse/properties/autogenerated_word_break.c
    src/parse/properties/autogenerated_word_wrap.c
    src/parse/properties/autogenerated_baseline_shift.c
    src/parse/properties/autogenerated_clip_path.c
    src/parse/properties/autogenerated_clip_rule.c
    src/parse/properties/autogenerated_comp_op.c
    src/parse/properties/autogenerated_enable_background.c
    src/parse/properties/autogenerated_fill.c
    src/parse/properties/fill.c
    src/parse/properties/autogenerated_fill_opacity.c
    src/parse/properties/fill_opacity.c
    src/parse/properties/autogenerated_fill_rule.c
    src/parse/properties/autogenerated_filter.c
    src/parse/properties/filter.c
    src/parse/properties/autogenerated_flood_color.c
    src/parse/properties/autogenerated_flood_opacity.c
    src/parse/properties/flood_opacity.c
    src/parse/properties/autogenerated_font_stretch.c
    src/parse/properties/autogenerated_marker_end.c
    src/parse/properties/autogenerated_marker_mid.c
    src/parse/properties/autogenerated_marker_start.c
    src/parse/properties/autogenerated_mask.c
    src/parse/properties/autogenerated_shape_rendering.c
    src/parse/properties/autogenerated_stop_color.c
    src/parse/properties/autogenerated_stop_opacity.c
    src/parse/properties/stop_opacity.c
    src/parse/properties/autogenerated_stroke.c
    src/parse/properties/stroke.c

=== src/third-party/libparserutils/CMakeLists.txt ===
#
# 
#                           IMPORTANT NOTICE
# 
#  The following open source license statement does not apply to any
#  entity in the Exception List published by FMSoft.
# 
#  For more information, please visit:
# 
#  https://www.fmsoft.cn/exception-list
# 
#
#   This file is part of DOM Ruler. DOM Ruler is a library to
#   maintain a DOM tree, lay out and stylize the DOM nodes by
#   using CSS (Cascaded Style Sheets).
#
#   Copyright (C) 2021 Beijing FMSoft Technologies Co., Ltd.
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#   Or,
#
#   As this program is a library, any link to this program must follow
#   GNU General Public License version 3 (GPLv3). If you cannot accept
#   GPLv3, you need to be licensed from FMSoft.
#
#   If you have got a commercial license of this program, please use it
#   under the terms and conditions of the commercial license.
#
#   For more information about the commercial license, please refer to
#   <http://www.minigui.com/blog/minigui-licensing-policy/>.
#

cmake_minimum_required(VERSION 3.10)

project(parserutils)
add_definitions(-fPIC)

list(APPEND parserutils_INCLUDE_DIRECTORIES
    include
    src
)

list(APPEND parserutils_SOURCES
    src/charset/aliases.c
    src/charset/codecs/codec_utf8.c
    src/charset/codecs/codec_ext8.c
    src/charset/codecs/codec_utf16.c
    src/charset/codecs/codec_ascii.c
    src/charset/codecs/codec_8859.c
    src/charset/encodings/utf8.c
    src/charset/encodings/utf16.c
    src/charset/codec.c
    src/input/inputstream.c
    src/input/filter.c
    src/utils/errors.c
    src/utils/buffer.c
    src/utils/vector.c
    src/utils/stack.c
)

include_directories(${parserutils_INCLUDE_DIRECTORIES})
add_library(parserutils STATIC ${parserutils_SOURCES})

=== src/third-party/libwapcaplet/CMakeLists.txt ===
#
# 
#                           IMPORTANT NOTICE
# 
#  The following open source license statement does not apply to any
#  entity in the Exception List published by FMSoft.
# 
#  For more information, please visit:
# 
#  https://www.fmsoft.cn/exception-list
# 
#
#   This file is part of DOM Ruler. DOM Ruler is a library to
#   maintain a DOM tree, lay out and stylize the DOM nodes by
#   using CSS (Cascaded Style Sheets).
#
#   Copyright (C) 2021 Beijing FMSoft Technologies Co., Ltd.
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#   Or,
#
#   As this program is a library, any link to this program must follow
#   GNU General Public License version 3 (GPLv3). If you cannot accept
#   GPLv3, you need to be licensed from FMSoft.
#
#   If you have got a commercial license of this program, please use it
#   under the terms and conditions of the commercial license.
#
#   For more information about the commercial license, please refer to
#   <http://www.minigui.com/blog/minigui-licensing-policy/>.
#

cmake_minimum_required(VERSION 3.10)

project(wapcaplet)
add_definitions(-fPIC)

list(APPEND wapcaplet_INCLUDE_DIRECTORIES
    include
    src
)

list(APPEND wapcaplet_SOURCES
    src/libwapcaplet.c
)

include_directories(${wapcaplet_INCLUDE_DIRECTORIES})
add_library(wapcaplet STATIC ${wapcaplet_SOURCES})

=== src/tools/layout_html/CMakeLists.txt ===
#
# 
#                           IMPORTANT NOTICE
# 
#  The following open source license statement does not apply to any
#  entity in the Exception List published by FMSoft.
# 
#  For more information, please visit:
# 
#  https://www.fmsoft.cn/exception-list
# 
#
#   This file is part of DOM Ruler. DOM Ruler is a library to
#   maintain a DOM tree, lay out and stylize the DOM nodes by
#   using CSS (Cascaded Style Sheets).
#
#   Copyright (C) 2021 Beijing FMSoft Technologies Co., Ltd.
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU Lesser General License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU Lesser General License for more details.
#
#   You should have received a copy of the GNU Lesser General License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#   Or,
#
#   As this program is a library, any link to this program must follow
#   GNU Lesser General License version 3 (LLGPLv3). If you cannot accept
#   LLGPLv3, you need to be licensed from FMSoft.
#
#   If you have got a commercial license of this program, please use it
#   under the terms and conditions of the commercial license.
#
#   For more information about the commercial license, please refer to
#   <http://www.minigui.com/blog/minigui-licensing-policy/>.
#

cmake_minimum_required(VERSION 3.10)

project(layout_html)

# layout_html
list(APPEND layout_html_INCLUDE_DIRECTORIES
    ${CMAKE_SOURCE_DIR}/src/layout/include
)

list(APPEND layout_html_SOURCES
    ${CMAKE_SOURCE_DIR}/src/tools/layout_html/layout_html.c
)

include_directories(${layout_html_INCLUDE_DIRECTORIES} ${GLIB_INCLUDE_DIRS})
add_executable(layout_html ${layout_html_SOURCES})
target_link_libraries(layout_html domruler ${GLIB_LIBRARIES})

=== src/third-party/libcss/examples/CMakeLists.txt ===
#
# 
#                           IMPORTANT NOTICE
# 
#  The following open source license statement does not apply to any
#  entity in the Exception List published by FMSoft.
# 
#  For more information, please visit:
# 
#  https://www.fmsoft.cn/exception-list
# 
#
#   This file is part of DOM Ruler. DOM Ruler is a library to
#   maintain a DOM tree, lay out and stylize the DOM nodes by
#   using CSS (Cascaded Style Sheets).
#
#   Copyright (C) 2021 Beijing FMSoft Technologies Co., Ltd.
#
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU Lesser General License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU Lesser General License for more details.
#
#   You should have received a copy of the GNU Lesser General License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#   Or,
#
#   As this program is a library, any link to this program must follow
#   GNU Lesser General License version 3 (LLGPLv3). If you cannot accept
#   LLGPLv3, you need to be licensed from FMSoft.
#
#   If you have got a commercial license of this program, please use it
#   under the terms and conditions of the commercial license.
#
#   For more information about the commercial license, please refer to
#   <http://www.minigui.com/blog/minigui-licensing-policy/>.
#

cmake_minimum_required(VERSION 3.10)

project(examples)

# css
list(APPEND examples_INCLUDE_DIRECTORIES
    ${CMAKE_SOURCE_DIR}/libparserutils/include
    ${CMAKE_SOURCE_DIR}/libwapcaplet/include
    ${CMAKE_SOURCE_DIR}/libcss/include
)

list(APPEND examples_SOURCES
    ${CMAKE_SOURCE_DIR}/libcss/examples/example1.c
)

include_directories(${examples_INCLUDE_DIRECTORIES})
add_executable(examples ${examples_SOURCES})
target_link_libraries(examples hicss)

=== debian/changelog ===
hvml-dom-ruler (0.0.1-1) unstable; urgency=medium

  * Initial release (Closes: #nnnn)  <nnnn is the bug number of your ITP>

 -- lichenggang <lichenggang@uniontech.com>  Thu, 25 Aug 2022 17:18:20 +0800

=== debian/control ===
Source: hvml-dom-ruler
Section: libs
Priority: optional
Maintainer: Vincent Wei <vincent@minigui.org>
Build-Depends: debhelper (>= 11), cmake, libglib2.0-dev, libhvml-purc-dev, hvml-purc-bin
Standards-Version: 4.1.3
Homepage: https://github.com/HVML/DOM-Ruler

Package: hvml-dom-ruler
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: DOM Ruler is a library to maintain a DOM tree
 DOM Ruler is a library to maintain a DOM tree, lay out and stylize 
 the DOM elements by using CSS (Cascaded Style Sheets). 
 It integrates LibCSS (MIT licensed), LibParserUtils (MIT licensed) 
 and LibWapcaplet (MIT licensed) from open source community.
